
FOREST = 1
BURNING = 2
BURNED = 3

world = CellularSpace{
	xdim = 50,
	ydim = 50
}

world:createNeighborhood{
	strategy = "vonneumann",
	self = false
}

forEachCell(world, function(cell)
	cell.cover = FOREST
end)

legend = Legend {
	grouping = "uniquevalue",
	colorBar = {
		{value = FOREST, color = "green"},
		{value = BURNING, color = "red"},
		{value = BURNED, color = "brown"},
	}
}

Observer{
	subject = world,
	attributes = {"cover"},
	legends = {legend}
}

update = function(cs)
	forEachCell(cs, function(cell)
		if cell.cover == FOREST then
			forEachNeighbor(cell, function(cell, neighbor)
				if neighbor.cover == BURNING then
					cell.cover = BURNING
				end
			end)
		elseif cell.cover == BURNING then
			cell.cover = BURNED
		end
	end)
end

world:sample().cover = BURNING
world:notify()

t = Timer{
	Event{action = function()
		update(world)
		world:notify()
	end}
}

t:execute(90)

